core::TLSSession Class Reference

`#include <TLSSession.h>`

Inheritance diagram for core::TLSSession:
[legend]
Collaboration diagram for core::TLSSession:
[legend]

## Public Member Functions

| TLSSession (EPoll &ePoll, TCPServer &server)
| ~TLSSession ()
virtual void | output (std::stringstream &out)
virtual void | protocol (std::string data) override
Public Member Functions inherited from core::TCPSession
| TCPSession (EPoll &ePoll, TCPServer &server, std::string text="")
| ~TCPSession ()
void | send ()
void | sendToAll ()
void | sendToAll (SessionFilter filter)
void | terminate ()
Public Member Functions inherited from core::TCPSocket
| TCPSocket (EPoll &ePoll)
| TCPSocket (EPoll &ePoll, std::string text)
| ~TCPSocket ()
void | connect (IPAddress &address)
Public Member Functions inherited from core::Socket
| Socket (EPoll &ePoll, std::string text="")
| ~Socket ()
void | shutdown (std::string text="unknown")
void | setDescriptor (int descriptor)
| Set the descriptor for the socket. More...
int | getDescriptor ()
| Get the descriptor for the socket. More...
bool | eventReceived (struct epoll_event event)
| Parse epoll event and call specified callbacks. More...
int | write (std::string data)
void | write (char *buffer, int length)
void | output (std::stringstream &out)
virtual void | onUnregister ()
virtual void | onUnregistered ()
| Called when the socket has finished unregistering for the epoll processing. More...
bool | needsToWrite ()

## Protected Member Functions

void | receiveData (char *buffer, int bufferLength) override
void | onRegister ()
| Called before the socket has registered with the epoll processing. More...
void | onRegistered ()
| Called after the socket has been registered with epoll processing. More...
Protected Member Functions inherited from core::TCPSession
virtual void | onDataReceived (char *data, int len) override
virtual void | onLineReceived (std::string line)
virtual void | onBlockReceived (std::string block)
virtual void | onConnected ()
void | setMode (Mode mode, int size=0)
Protected Member Functions inherited from core::Socket
void | setBufferSize (int length)
int | getBufferSize ()
virtual void | onDataReceived (std::string data)
| Called when data is received from the socket. More...

## Additional Inherited Members

Public Attributes inherited from core::TCPSession
Command * | grab = NULL
std::stringstream | out
TCPServer & | server
Public Attributes inherited from core::TCPSocket
IPAddress | ipAddress
Public Attributes inherited from core::Socket
bool | reset = false
Public Attributes inherited from core::Object
std::string | name
std::string | tag
Protected Attributes inherited from core::Socket
EPoll & | ePoll
bool | shutDown = false

## Detailed Description

TLSSession

Provides a network TLS socket.

For accessing TLS network functions use this object. The connection oriented nature of TLS provides a single client persistent connection with data error correction and a durable synchronous data connection.

## Constructor & Destructor Documentation

## TLSSession()

core::TLSSession::TLSSession | ( | EPoll & | ePoll,
|  | TCPServer & | server
| ) |  |

## ~TLSSession()

core::TLSSession::~TLSSession | ( |  | ) |

## Member Function Documentation

## onRegister()

void core::TLSSession::onRegister | ( |  | ) |

protectedvirtual

Called before the socket has registered with the epoll processing.

The onRegister method is called before the socket is registered with ePoll so objects extending the Socket definition can initialize the socket before receiving events. Evoked when the descriptor is set using setDescriptor for the socket.

Reimplemented from core::Socket.

## onRegistered()

void core::TLSSession::onRegistered | ( |  | ) |

protectedvirtual

Called after the socket has been registered with epoll processing.

Reimplemented from core::TCPSession.

## output()

void core::TLSSession::output | ( | std::stringstream & | out | ) |

virtual

The output method is called by a socket session (Session) and will output the detail information for the client socket. When extending TLSSocket or Session you can override the method to add attributes to the list.

Reimplemented from core::TCPSession.

## protocol()

void core::TLSSession::protocol | ( | std::string | data | ) |

overridevirtual

Override the protocol method to manage and control the session communications in your inherited session. If you do not override this method then the Session default will process the 'commands' added to the server object using the processRequest method on the session input.

When data is received within the session two modes are available to pass the data through the protocol method: LINE or BLOCK.

Reimplemented from core::TCPSession.

## receiveData()

void core::TLSSession::receiveData | ( | char * | buffer,
|  | int | bufferLength
| ) |  |

overrideprotectedvirtual

receiveData will read the data from the socket and place it in the socket buffer. TLS layer overrides this to be able to read from SSL.

Reimplemented from core::Socket.

The documentation for this class was generated from the following files:

- TLSSession.h
- TLSSession.cpp